#!/usr/bin/bash

ts=$(date +%s)

echo 'workers|opclass|run|type|relpages|total_exec_time|shared_blks_hit|shared_blks_read|shared_blks_dirtied|shared_blks_written|wal_records|wal_fpi|wal_bytes|count|count_cached|nearest|nearest_cached' > results-workers-$ts.csv

for db in test test2; do

	for ops in nd; do

		for r in 1; do

			for t in line point polygon roads; do

				for w in "-1"; do

pg_ctl -D /mnt/pgdata/data-osm -l pg.log stop
pg_ctl -D /mnt/pgdata/data-osm -l pg.log start

psql $db > /dev/null 2>&1 <<EOF
set min_parallel_table_scan_size = '64kB';
set maintenance_work_mem = '256MB';
set work_mem = '32MB';
set max_parallel_maintenance_workers = 0;
select pg_stat_statements_reset();
checkpoint;
drop index if exists idx;
create index idx on planet_osm_$t using gist (way gist_geometry_ops_$ops);
EOF

					s=$(psql -t -A $db -c "select relpages from pg_class where relname = 'idx'")

					i=$(psql -t -A $db -c "select total_exec_time, shared_blks_hit, shared_blks_read, shared_blks_dirtied, shared_blks_written, wal_records, wal_fpi, wal_bytes from pg_stat_statements where query like '%create index%'")

					timings=""

					for b in count nearest; do

						pg_ctl -D /mnt/pgdata/data-gist -l pg.log restart
						sudo ./drop-caches.sh

						x=$(psql -t -A $db -c "select extract(epoch from now())")
						psql -t -A $db < bench/$ops/$t-$b.sql
						t1=$(psql -t -A $db -c "select extract(epoch from now()) - $x")

						timings="$timings|$t1"

        	                                x=$(psql -t -A $db -c "select extract(epoch from now())")
                	                        psql -t -A $db < bench/$ops/$t-$b.sql
                        	                t1=$(psql -t -A $db -c "select extract(epoch from now()) - $x")

	                                        timings="$timings|$t1"

					done

					echo "$w|$ops|$r|$t|$s|$i$timings" >> results-workers-$ts.csv 2>&1

psql $db <<EOF
drop index idx;
EOF

				done

			done

		done

	done

done
